online-shop/online-shop/urls.py
from django.conf import settings
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.urls import include, path, re_path
from django.views.generic.base import TemplateView



admin.site.site_title = "Online-Shop Administration"
admin.site.site_header = "My Admin"
admin.site.index_title = "Welcome to the Admin Panel"

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('shoppingapp.urls')),
]

handler404 = 'online-shop.views.handler404'
handler500 = 'online-shop.views.handler500'

if settings.DEBUG:
	
	urlpatterns += [
		# Testing 404 and 500 error pages
		path('404/', TemplateView.as_view(template_name='404.html'), name='404'),
		path('500/', TemplateView.as_view(template_name='500.html'), name='500'),
		# path('/', TemplateView.as_view(template_name='index.html'), name='home'),
		# path('shop/', TemplateView.as_view(template_name='shop.html'), name='shop'),
		# path('detail/', TemplateView.as_view(template_name='detail.html'), name='detail'),
		# path('pages/', TemplateView.as_view(template_name='cart.html'), name='pages'),
		# path('contact/', TemplateView.as_view(template_name='contact.html'), name='contact'),
	]

	from django.conf.urls.static import static
	urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
	import debug_toolbar
	urlpatterns += [path('__debug__/', include(debug_toolbar.urls))]

online-shop/shoppingapp/urls.py
from django.urls import path
from . import views


app_name = 'shoppingapp'

urlpatterns = [
    path('home/', views.Home.as_view(), name='home'),
    path('shop/', views.ShopView.as_view(), name='shop'),
    path('detail/', views.DetailPageView.as_view(), name='detail'),
    path('pages/', views.CartView.as_view(), name='pages'),
    path('checkout/', views.CheckoutView.as_view(), name='checkout'),
    path('search/', views.SearchView.as_view(), name='search'),
    path('contact/', views.ContactFormView.as_view(), name='contact'),
    path('newsletter/', views.NewsLetterView.as_view(), name='newsletter'),
    path('signup/', views.SignUp.as_view(), name='signup'),
    path('signin/', views.Signin.as_view(), name='signin'),
    path('logout/', views.Logout.as_view(), name='logout'),
    path('shop/<slug:slug>/', views.ProductView.as_view(), name='shop_detail'),
    path('postcomment/', views.PostComment.as_view(), name='postcomment'),
    path('shopdetail/<int:Min>/<int:Max>', views.ShopDetailView.as_view(), name='shopdetail'),
    path('color/<str:str>', views.ColorView.as_view(), name='color'),
    path('shopcategory/<slug:slug>/', views.Shoppcategory.as_view(), name='shopcat'),

]

online-shop/shoppingapp/models.py
from django.db import models
from django.urls import reverse
from django_extensions.db.fields import AutoSlugField
from django_extensions.db.models import TimeStampedModel
from mptt.models import MPTTModel, TreeForeignKey

from utils import enums


# home page products
class Product(TimeStampedModel):
    product_name = models.CharField(max_length=100)
    images = models.ImageField(upload_to='media', null=True, blank=True)
    price = models.CharField(null=True, max_length=1000)
    is_published = models.BooleanField(default=True)

    class Meta:
        verbose_name = "Product_Image"

    def __str__(self):
        return self.price


# shop page
class Shop(TimeStampedModel):
    product_name = models.CharField(max_length=100)
    images = models.ImageField(upload_to='media', null=True, blank=True)
    price = models.IntegerField(null=True, blank=True)
    colors = models.CharField(max_length=50, null=True, blank=True, choices=enums.COLORS, unique=False)
    slug = AutoSlugField(populate_from=['product_name'], null=True, blank=True)
    catt = models.ForeignKey('ShopCategory', on_delete=models.CASCADE, null=True, blank=True)

    class Meta:
        verbose_name = "Shop_Image"

    def __str__(self):
        return self.product_name

    def get_absolute_url(self):
        return reverse('detail', kwargs={'slug': self.slug})


# home page
class Category(TimeStampedModel):
    category_name = models.CharField(max_length=100)
    images = models.ImageField(upload_to='media', null=True, blank=True)
    product = models.CharField(max_length=100)

    class Meta:
        verbose_name = "Categorie"

    def __str__(self):
        return self.category_name


# detail page
class ShopDescription(TimeStampedModel):
    name = models.CharField(max_length=100, null=True, blank=True)
    description = models.TextField(null=True, max_length=10000)
    price = models.CharField(null=True, max_length=1000)
    information = models.TextField(null=True, max_length=10000)
    sizes = models.CharField(max_length=50, null=True, blank=True, choices=enums.SIZES, unique=True)
    colors = models.CharField(max_length=50, null=True, blank=True, choices=enums.COLORS, unique=True)

    class Meta:
        verbose_name = "ShopDescription"

    def __str__(self):
        return self.description


class CommentReview(TimeStampedModel):
    review = models.TextField()
    name = models.CharField(max_length=100, null=True, blank=True)
    email = models.EmailField(max_length=100, null=True, blank=True)
    post = models.ForeignKey(Shop, on_delete=models.CASCADE, related_name='comments')

    class Meta:
        verbose_name = "Review"

    def __str__(self):
        return self.name


class Contact(models.Model):
    Name = models.CharField(max_length=100, null=True, blank=True)
    Email = models.EmailField(max_length=100, null=True, blank=True)
    Subject = models.CharField(max_length=215, null=True, blank=True)
    Message = models.TextField(null=True, blank=True)

    class Meta:
        verbose_name_plural = "ContactUs"
        verbose_name = "ContactUs"
        ordering = ["Name", "Email", "Subject", "Message"]

    def __str__(self):
        return self.Name


class NewsLetter(TimeStampedModel):
    email = models.EmailField(max_length=100, null=True, blank=True)

    class Meta:
        verbose_name_plural = "NewsLetter"
        ordering = ["email"]

    def __str__(self):
        return self.email


class ShopCategory(MPTTModel):
    name = models.CharField(max_length=150)
    parent = TreeForeignKey('self', on_delete=models.CASCADE, null=True, blank=True, related_name='children')
    slug = AutoSlugField(populate_from=['name'], null=True, blank=True)

    class MPTTMeta:
        order_insertion_by = ['name']

    class Meta:
        verbose_name_plural = "shopcategories"
        ordering = ["name"]

    def __str__(self):
        return self.name

    # def get_absolute_url(self):
    #     return reverse('cat', kwargs={'slug': self.slug})

online-shop/shoppingapp/forms.py
from django import forms
from shoppingapp import models
from django.forms import ModelForm
from django import forms
from django.core import validators
from django.contrib.auth import get_user_model, authenticate

from user.models import User
from .models import *


class CreateForm(forms.ModelForm):
    email = forms.EmailField()

    class Meta:
        model = User
        fields = '__all__'

class Commentreviewform(forms.ModelForm):
    class Meta:
        model = CommentReview
        fields = '__all__'


class ContactCreateForm(forms.Form):
    name = forms.CharField(max_length=255)
    email = forms.EmailField(max_length=255)
    subject = forms.CharField(max_length=100)
    message = forms.CharField(max_length=250)



class NewsForm(forms.ModelForm):
    class Meta:
        model= NewsLetter
        fields = '__all__'

online-shop/shoppingapp/views.py
import form as form
from django.contrib.auth import authenticate, logout, login
from django.core.mail import send_mail
from django.db.models import Min, Max
from django.http import HttpResponse
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views import generic
from django.views.generic import FormView, DetailView, CreateView, ListView
from django.views.generic import TemplateView
from django.views.generic.base import View
from mptt.forms import TreeNodeChoiceField

from .models import *
from shoppingapp import models, forms
# from .forms import *

#By Function-based View
"""
def ShopDetailView(request, Min=0, Max=0):
    shop = models.Shop.objects.filter(price__range=(Min, Max))
    context = {'shop':shop}
    return render(request, 'shoppingapp/shop.html', context)
"""

# class SignUp(generic.View):
#
#     def get(self, request, *args, **kwargs):
#         return render(request, "shoppingapp/signup.html")
#
#     def post(self, request, *args, **kwargs):
#         email = request.POST['email']
#         first_name = request.POST['first_name']
#         last_name = request.POST['last_name']
#         password = request.POST['password']
#         password2 = request.POST['password2']
#         user = models.User.objects.filter(email=email)
#         if user:
#             message = "User is already exist"
#             context = {"message": message}
#             return render(request, 'shoppingapp/index.html', context)
#         else:
#             if password == password2:
#                 data = {
#                     "email": email,
#                     "first_name": first_name,
#                     "last_name": last_name,
#                 }
#                 user_obj = models.User.objects.create(**data)
#                 user_obj.set_password(password)
#                 user_obj.save()
#                 return redirect('shoppingapp:home')
#             message = "Password and Re-enter password not matching.."
#             context = {"message": message}
#             return render(request, 'shoppingapp/index.html', context)

# def home(request):
#     return render(request, "shoppingapp/index.html")

# def shop(request):
#     return render(request, "shoppingapp/shop.html")

# def detail(request):
#     return render(request, "shoppingapp/detail.html")

# def cart(request):
#     return render(request, "shoppingapp/cart.html")

# def contact(request):
#     return render(request, "shoppingapp/contact.html")

# def checkout(request):
#     return render(request, "shoppingapp/checkout.html")

#Home Page
class Home(TemplateView):
    template_name = "shoppingapp/index.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['category'] = models.Category.objects.all()
        context['product'] = models.Product.objects.filter(is_published=True)
        context['queryset'] = models.Product.objects.all()
        context['parent_item'] = models.ShopCategory.objects.filter(level=0)[1:]
        context['child_item'] = models.ShopCategory.objects.filter(level=1)
        print(context)
        return context

#Shop Page
class ShopView(TemplateView):
    template_name = "shoppingapp/shop.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        # category = models.ShopCategory.objects.filter(subcategory__name__iexact='category')
        my_shop = models.Shop.objects.all()
        context = {'shop': my_shop}
        return context

#Shop Page
class ShopDetailView(ListView):
    template_name = "shoppingapp/shop.html"

    def get(self, request, *args, **kwargs):
        Min = self.kwargs.get('Min')
        Max = self.kwargs.get('Max')

        shop = models.Shop.objects.filter(price__range=(Min, Max))
        context = {"shop": shop}
        return render(request, "shoppingapp/shop.html", context)

#Shop Page
class ColorView(ListView):
    template_name = "shoppingapp/shop.html"

    def get(self, request, *args, **kwargs):
        color = self.kwargs.get('str')
        shop = models.Shop.objects.filter(colors=color)
        context = {"shop": shop}
        return render(request, "shoppingapp/shop.html", context)

#Home Page
class ProductView(DetailView):
    model = Shop
    # queryset = models.Shop.objects.filter()
    # slug_field = 'product_name'
    template_name = "shoppingapp/detail.html"

    # def get_queryset(self):
    #     return models.Shop.objects.filter()

    # def get_context_data(self, **kwargs):
    #     context = super().get_context_data(**kwargs)
    #     context['queryset'] = models.Shop.objects.filter()
    #     return context

#Detail Page
class DetailPageView(TemplateView):
    template_name = "shoppingapp/detail.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['queryset'] = models.ShopDescription.objects.all()
        return context

#Cart Page
class CartView(TemplateView):
    template_name = "shoppingapp/cart.html"

#Search Page
class SearchView(TemplateView):
    template_name = "shoppingapp/search.html"

    def get(self, request, *args, **kwargs):
        query = request.GET['query']
        queryset = models.Shop.objects.filter(product_name__icontains=query)
        context = {'queryset': queryset}
        return render(request, 'shoppingapp/search.html', context)

class CheckoutView(TemplateView):
    template_name = "shoppingapp/checkout.html"


class SignUp(FormView):
    template_name = 'shoppingapp/signup.html'
    success_url = reverse_lazy('shoppingapp:home')
    form_class = forms.CreateForm

    def form_valid(self, form):
        form.save()
        user = models.User.objects.get(email=form.data.get('email'))
        user.is_active = True
        user.set_password(form.data.get('password'))
        user.save()
        return super(SignUp, self).form_valid(form)


class Signin(generic.View):
    def get(self, request, *args, **kwargs):
        return render(request, "shoppingapp/signin.html")

    def post(self, request, *args, **kwargs):
        email = request.POST["email"]
        password = request.POST["password"]
        user = authenticate(request, email=email, password=password)

        if user is not None:
            login(request, user)
            return redirect('shoppingapp:home')
        else:
            return redirect('shoppingapp:signin')


class Logout(View):
    def get(self, request):
        logout(request)
        return redirect('shoppingapp:home')

#Reviews Start
class PostComment(FormView):
    def get(self, request, *args, **kwargs):
        return render(request, "shoppingapp/index.html")

    def post(self, request, *args, **kwargs):
        if request.method == "POST":
            form = forms.Commentreviewform(request.POST)
            if form.is_valid():
                form.save()
                return redirect("/detail")

class ContactFormView(FormView):
    template_name = "shoppingapp/contact.html"
    success_url = reverse_lazy('shoppingapp:contact')

    def get(self, request, *args, **kwargs):
        return render(request, "shoppingapp/contact.html")

    def post(self, request, *args, **kwargs):

        if request.method == 'POST':
            form = forms.ContactCreateForm(request.POST)
            if form.is_valid():
                name = form.cleaned_data['name']
                email = form.cleaned_data['email']
                subject = form.cleaned_data['subject']
                message = form.cleaned_data['message']

                contact = Contact(Name=name, Email=email, Subject=subject, Message=message)
                contact.save()

            return render(request, "shoppingapp/index.html")


class NewsLetterView(CreateView):
    # form_class = forms.NewsForm
    template_name = "shoppingapp/index.html"
    # success_url = reverse_lazy('shoppingapp:home')


    def post(self, request, *args, **kwargs):

            form = forms.NewsForm(request.POST)
            if form.is_valid():
                email = form.cleaned_data['email']
                form.save()
                send_mail(
                    'Subject here',
                    'Here is the message.',
                    'from@example.com',
                    [f'{email}'],
                    fail_silently=False,
                )
                return redirect('shoppingapp:home')


class Shoppcategory(ListView):
    template_name = "shoppingapp/shopcat.html"
    model = Shop

    def get(self, request, catt=None, *args, **kwargs):
        cat = self.kwargs.get('slug')
        if not cat.isalpha():
            query = models.Shop.objects.filter(catt=cat)
        else:
            query = models.Shop.objects.filter(product_name__icontains=cat)
        context={'query': query}
        return render(request, "shoppingapp/shopcat.html", context)

online-shop/templates/shoppingapp/base.html
{% load static %}
<html lang="en">


<head>
    <meta charset="utf-8">
    <title>MultiShop - Online Shop Website Template</title>
    <meta content="width=device-width, initial-scale=1.0" name="viewport">
    <meta content="Free HTML Templates" name="keywords">
    <meta content="Free HTML Templates" name="description">

    <!-- Favicon -->
    <link href="{% static 'shoppingapp/img/favicon.ico' %}" rel="icon">

    <!-- Google Web Fonts -->
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@400;500;700&display=swap" rel="stylesheet">

    <!-- Font Awesome -->
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.10.0/css/all.min.css" rel="stylesheet">

    <!-- Libraries Stylesheet -->
    <link href="{% static 'shoppingapp/lib/animate/animate.min.css' %}" rel="stylesheet">
    <link href="{% static 'shoppingapp/lib/owlcarousel/assets/owl.carousel.min.css' %}" rel="stylesheet">

    <!-- Customized Bootstrap Stylesheet -->
    <link href="{% static 'shoppingapp/css/style.css' %}" rel="stylesheet">
</head>

<body>
{% include 'shoppingapp/header.html' %}

{% block content %}


{% endblock %}

{% include 'shoppingapp/footer.html' %}

<!-- JavaScript Libraries -->
    <script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.bundle.min.js"></script>
    <script src="{% static 'shoppingapp/lib/easing/easing.min.js' %}"></script>
    <script src="{% static 'shoppingapp/lib/owlcarousel/owl.carousel.min.js' %}"></script>

    <!-- Contact Javascript File -->
    <script src="{% static 'shoppingapp/mail/jqBootstrapValidation.min.js' %}"></script>
    <script src="{% static 'shoppingapp/mail/contact.js' %}"></script>

    <!-- Template Javascript -->
    <script src="{% static 'shoppingapp/js/main.js' %}"></script>
</body>
</html>

online-shop/templates/shoppingapp/confirm.html
{#{% extends "shoppingapp/base.html" %}#}
{#{% block content %}#}
{#{% for post in posts %}#}
{#        <article class="media content-section">#}
{#          <div class="media-body">#}
{#            <div class="article-metadata">#}
{#              <a class="mr-2">{{ post.category }}</a>#}
{#            </div>#}
{#            <h2><a class="article-title" >{{ post.title }}</a></h2>#}
{#            <p class="article-content"> Price: ${{ post.Price }}</p>#}
{#            <p class="article-content"> Sale: ${{ post.Sale }}</p>#}
{#            <input type="checkbox" id="product_{{ post.id }}" value="{{ post.title }}" form="menuForm" name="products" > Inventory count: {{ post.quantity }}#}
{#          </input>#}
{#          </div>#}
{#        </article>#}
{#{% endfor %}#}
{#{% endblock %}#}

online-shop/templates/shoppingapp/footer.html
{% load static %}

<!-- Footer Start -->
    <div class="container-fluid bg-dark text-secondary mt-5 pt-5">
        <div class="row px-xl-5 pt-5">
            <div class="col-lg-4 col-md-12 mb-5 pr-3 pr-xl-5">
                <h5 class="text-secondary text-uppercase mb-4">Get In Touch</h5>
                <p class="mb-4">No dolore ipsum accusam no lorem. Invidunt sed clita kasd clita et et dolor sed dolor. Rebum tempor no vero est magna amet no</p>
                <p class="mb-2"><i class="fa fa-map-marker-alt text-primary mr-3"></i>123 Street, New York, USA</p>
                <p class="mb-2"><i class="fa fa-envelope text-primary mr-3"></i>{{ config.EMAIL }}</p>
                <p class="mb-0"><i class="fa fa-phone-alt text-primary mr-3"></i>{{ config.PHONE }}</p>
            </div>
            <div class="col-lg-8 col-md-12">
                <div class="row">
                    <div class="col-md-4 mb-5">
                        <h5 class="text-secondary text-uppercase mb-4">Quick Shop</h5>
                        <div class="d-flex flex-column justify-content-start">
                            <a class="text-secondary mb-2" href={% url 'shoppingapp:home' %}><i class="fa fa-angle-right mr-2"></i>Home</a>
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:shop' %}"><i class="fa fa-angle-right mr-2"></i>Our Shop</a>
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:detail' %}"><i class="fa fa-angle-right mr-2"></i>Shop Detail</a>
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:pages' %}"><i class="fa fa-angle-right mr-2"></i>Shopping Cart</a>
                            <a class="text-secondary mb-2" href="#"><i class="fa fa-angle-right mr-2"></i>Checkout</a>
                            <a class="text-secondary" href="{% url 'shoppingapp:contact' %}"><i class="fa fa-angle-right mr-2"></i>Contact Us</a>
                        </div>
                    </div>
                    <div class="col-md-4 mb-5">
                        <h5 class="text-secondary text-uppercase mb-4">My Account</h5>
                        <div class="d-flex flex-column justify-content-start">
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:home' %}"><i class="fa fa-angle-right mr-2"></i>Home</a>
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:shop' %}"><i class="fa fa-angle-right mr-2"></i>Our Shop</a>
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:detail' %}"><i class="fa fa-angle-right mr-2"></i>Shop Detail</a>
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:pages' %}"><i class="fa fa-angle-right mr-2"></i>Shopping Cart</a>
                            <a class="text-secondary mb-2" href="{% url 'shoppingapp:checkout' %}"><i class="fa fa-angle-right mr-2"></i>Checkout</a>
                            <a class="text-secondary" href="{% url 'shoppingapp:contact' %}"><i class="fa fa-angle-right mr-2"></i>Contact Us</a>
                        </div>
                    </div>
                    <div class="col-md-4 mb-5">
                        <h5 class="text-secondary text-uppercase mb-4">Newsletter</h5>
                        <p>Duo stet tempor ipsum sit amet magna ipsum tempor est</p>
                        <form method="post" action="{% url 'shoppingapp:newsletter' %}">
                            {% csrf_token %}
{#                            {{ form.as_div }}#}
                            <div class="input-group">
                                <input type="email" class="form-control" name="email" placeholder="Your Email Address">
                                <div class="input-group-append">
                                    <button class="btn btn-primary" type="submit">Sign Up</button>
                                </div>
                            </div>
                        </form>
                        <h6 class="text-secondary text-uppercase mt-4 mb-3">Follow Us</h6>
                        <div class="d-flex">
                            <a class="btn btn-primary btn-square mr-2" href="{{ config.TWITTER  }}"><i class="fab fa-twitter"></i></a>
                            <a class="btn btn-primary btn-square mr-2" href="{{ config.FACEBOOK  }}"><i class="fab fa-facebook-f"></i></a>
                            <a class="btn btn-primary btn-square mr-2" href="{{ config.LINKEDIN  }}"><i class="fab fa-linkedin-in"></i></a>
                            <a class="btn btn-primary btn-square" href="{{ config.INSTAGRAM  }}"><i class="fab fa-instagram"></i></a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row border-top mx-xl-5 py-4" style="border-color: rgba(256, 256, 256, .1) !important;">
            <div class="col-md-6 px-xl-0">
                <p class="mb-md-0 text-center text-md-left text-secondary">
                    &copy; <a class="text-primary" href="#">Domain</a>. All Rights Reserved. Designed
                    by
                    <a class="text-primary" href="https://htmlcodex.com">HTML Codex</a>
                </p>
            </div>
            <div class="col-md-6 px-xl-0 text-center text-md-right">
                <img class="{% static 'shoppingapp/img-fluid" src="img/payments.png' %}" alt="">
            </div>
        </div>
    </div>
    <!-- Footer End -->

online-shop/templates/shoppingapp/search.html
{% extends 'shoppingapp/base.html' %}
{% load static %}
{% block content %}
    {% for p in queryset %}
        <div class="col-lg-4 col-md-6 col-sm-6 pb-1">

                        <div class="product-item bg-light mb-4">
                            <div class="product-img position-relative overflow-hidden">
                                <img class="img-fluid w-100" src="{{ p.images.url }}" alt="">
                                <div class="product-action">
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="fa fa-shopping-cart"></i></a>
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="far fa-heart"></i></a>
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="fa fa-sync-alt"></i></a>
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="fa fa-search"></i></a>
                                </div>
                            </div>
                            <div class="text-center py-4">
                                <a class="h6 text-decoration-none text-truncate" href="{% url 'shoppingapp:shop_detail' p.slug %}">{{ p.product_name }}</a>
                                <div class="d-flex align-items-center justify-content-center mt-2">
                                    <h5>${{ p.price }}</h5><h6 class="text-muted ml-2"><del>$123.00</del></h6>
                                </div>
                                <div class="d-flex align-items-center justify-content-center mb-1">
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small>(99)</small>
                                </div>
                            </div>
                        </div>
                    </div>

    {% endfor %}


{% endblock %}

online-shop/templates/shoppingapp/shopcat.html
{% extends 'shoppingapp/base.html' %}
{% load static %}
{% block content  %}
    <div>
<h5>Search Result:</h5>
    {% if query|length < 1 %}
    <p>No Product Found</p>
    {% endif %}
    </div>
{% for i in query %}



    <div class="col-lg-4 col-md-6 col-sm-6 pb-1">

                        <div class="product-item bg-light mb-4">
                            <div class="product-img position-relative overflow-hidden">
                                <img class="img-fluid w-100" src="{{ i.images.url }}" alt="">
                                <div class="product-action">
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="fa fa-shopping-cart"></i></a>
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="far fa-heart"></i></a>
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="fa fa-sync-alt"></i></a>
                                    <a class="btn btn-outline-dark btn-square" href=""><i class="fa fa-search"></i></a>
                                </div>
                            </div>
                            <div class="text-center py-4">
                                <a class="h6 text-decoration-none text-truncate" href="{% url 'shoppingapp:shop_detail' i.slug %}">{{ i.product_name }}</a>
                                <br><a class="h6 text-decoration-none text-truncate" href="{% url 'shoppingapp:shop' %}">{{ i.colors }}</a></br>
                                <div class="d-flex align-items-center justify-content-center mt-2">
                                    <h5>${{ i.price }}</h5><h6 class="text-muted ml-2"><del>$123.00</del></h6>
                                </div>
                                <div class="d-flex align-items-center justify-content-center mb-1">
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small class="fa fa-star text-primary mr-1"></small>
                                    <small>(99)</small>
                                </div>
                            </div>
                        </div>
                    </div>
    {% endfor %}

{% endblock %}

online-shop/templates/shoppingapp/signin.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
   <head>
      <!-- basic -->
      <meta charset="utf-8">
      <meta http-equiv="X-UA-Compatible" content="IE=edge">
      <!-- mobile metas -->
      <meta name="viewport" content="width=device-width, initial-scale=1">
   </head>
    <body>
        <form action="{% url 'shoppingapp:signin' %}" method="POST">
        {% csrf_token %}
           <input type="text" name="email" placeholder="email"><br>
           <input type="password" name="password" placeholder="Password"><br>
           <input type="Submit">
        </form>
    </body>
</html>

online-shop/templates/shoppingapp/signup.html
<!DOCTYPE html>
<html lang="en">
   <head>
      <!-- basic -->
      <meta charset="utf-8">
      <meta http-equiv="X-UA-Compatible" content="IE=edge">
   </head>
<body>
   <form action="{% url 'shoppingapp:signup' %}" method="post">
       {% csrf_token %}
       <input type="text" name="first_name" placeholder="First Name"><br>
       <br><input type="text" name="last_name" placeholder="Last Name"></br>
       <br><input type="text" name="email" placeholder="email"></br>
       <br><input type="password" name="password" placeholder="Password"></br>
       <br><input type="password" name="password2" placeholder="Password2"></br>
       <button type="submit">click</button>

   </form>
</body>
</html>